


-- milling support





local enabled = true


do
-- results : [pigment][herb] = numMilled
	local millingResults = {
		[13464] = {
			[39341] = 2.7,
			[43107] = 0.4,
		},
		[13465] = {
			[39341] = 2.7,
			[43107] = 0.4,
		},
		[4625] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[3820] = {
			[43103] = 0.4,
			[39334] = 2.7,
		},
		[22789] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[22787] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[8838] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[3356] = {
			[43104] = 0.4,
			[39338] = 2.7,
		},
		[2453] = {
			[43103] = 0.4,
			[39334] = 2.7,
		},
		[8836] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[22786] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[36904] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[3818] = {
			[43105] = 0.4,
			[39339] = 2.7,
		},
		[22792] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[8845] = {
			[39340] = 2.7,
		},
		[2452] = {
			[43103] = 0.4,
			[39334] = 2.7,
		},
		[8831] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[39970] = {
			[39343] = 2.7,
		},
		[13463] = {
			[39341] = 2.7,
			[43107] = 0.4,
		},
		[37921] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[36906] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[2450] = {
			[43103] = 0.4,
			[39334] = 2.7,
		},
		[36901] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[2447] = {
			[39151] = 2.7,
		},
		[3369] = {
			[43104] = 0.4,
			[39338] = 2.7,
		},
		[2449] = {
			[39151] = 2.7,
		},
		[8846] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[22793] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[3355] = {
			[43104] = 0.4,
			[39338] = 2.7,
		},
		[22790] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[36907] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[3821] = {
			[43105] = 0.4,
			[39339] = 2.7,
		},
		[3819] = {
			[43105] = 0.4,
			[39339] = 2.7,
		},
		[36903] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[3357] = {
			[43104] = 0.4,
			[39338] = 2.7,
		},
		[765] = {
			[39151] = 2.7,
		},
		[3358] = {
			[43105] = 0.4,
			[39339] = 2.7,
		},
		[13466] = {
			[39341] = 2.7,
			[43107] = 0.4,
		},
		[13467] = {
			[39341] = 2.7,
			[43107] = 0.4,
		},
		[8839] = {
			[39340] = 2.7,
			[43106] = 0.4,
		},
		[36905] = {
			[43109] = 0.4,
			[39343] = 2.7,
		},
		[22785] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[22791] = {
			[39342] = 2.7,
			[43108] = 0.4,
		},
		[785] = {
			[43103] = 0.4,
			[39334] = 2.7,
		},
	}


	local pigmentSources = {}


	local function BuildPigmentSources()
		for herbID, pigmentTable in pairs(millingResults) do
			for pigmentID, count in pairs(pigmentTable) do
				if not pigmentSources[pigmentID] then
					pigmentSources[pigmentID] = {}
				end

				pigmentSources[pigmentID][herbID] = count
			end
		end
	end


	-- spoof recipes for milled herbs -> pigments
	local function AddToRecipeCache()
		for herbID, pigmentTable in pairs(millingResults) do
			local reagentTable = {}
			local recipeName = "Mill "..(GetItemInfo(herbID) or "item:"..herbID)

			reagentTable[herbID] = 5

			LSW:AddRecipe(-herbID, recipeName, pigmentTable, reagentTable, true)
		end
	end



	local function GetMillingSources(itemID)
		return millingResults[itemID]
	end


	local function GetMillingValue(itemID)
		local millingTable = millingResults[itemID]

		local value = 0

		if (millingTable) then
			for pigmentID, count in pairs(millingTable) do
				value = value + (LSW.auctionValue(pigmentID) or 0) * (count or 1)
			end

			return value
		end
	end


	local function GetPigmentSources(itemID)
		return pigmentSources[itemID]
	end



	local function Init()
		LSW:ChatMessage("LilSparky's Workshop adding native Milling support")

		BuildPigmentSources()
		AddToRecipeCache()

		LSW.getMillingValue = GetMillingValue
		LSW.getMillingResults = GetMillingSources
		LSW.getPigmentSources = GetPigmentSources
	end


	local function Test(index)
		if enabled then
			return true
		end

		return false
	end

	LSW:RegisterPricingSupport("Milling", Test, Init)
end


